package nl.amis.hierarchical.model;

import java.util.ArrayList;
import java.util.List;

public class GeographyManager {
    
    List<Region> regions = new ArrayList<Region>();

    public void setRegions(List<Region> regions) {
        this.regions = regions;
    }

    public List<Region> getRegions() {
        return regions;
    }

    public List<City> getWorldCities() {
        List<City> cities = new ArrayList<City>();
        for (Region r :regions) {
            for (Continent c:r.getContinents()) {
                 for (Country u: c.getCountries())   
                   cities.addAll(u.getRealCities());
            }
            }
    return cities;
        }
    
    public List<Continent> getWorldContinents() {
        List<Continent> continents = new ArrayList<Continent>();
        for (Region r :regions) {
                   continents.addAll(r.getContinents());
            }
            
    return continents;
        }
    

    public GeographyManager() {
        super();
        //apac, emea, latinAmerica, usaAndCanada
        Region r = new Region("North Americas","NA",530000000L);
        Continent c = new Continent("North America", "NA", "northAmerica",530000000L);
        Country u = new Country("USA","USA",313000000L);
        u.getRealCities().add(new City("New York","New York", 20464000L,40.7143528f , -74.005973f));
        u.getRealCities().add(new City("Los Angeles","Los Angeles", 14900000L, 34.0522342f , -118.243684f));
        u.getRealCities().add(new City("Dallas-Fort Worth","Dallas-Fort Worth", 5800000L, 32.7801399f , -96.800451f));
        c.getRealCountries().add(u);
        c.getRealCountries().add(new Country("Canada","CAN",33000000L));
        u = new Country("Mexico","MEX",117000000L);
        u.getRealCities().add(new City("Mexico Ciudad","Mexico Ciudad", 19500000L,19.4326077f , 99.13320799999f));
        u.getRealCities().add(new City("Guadalajara","Guadalajara", 4500000L,20.6735f , -103.343802999f));
        c.getRealCountries().add(u);
        c.getRealCountries().add(new Country("Nicaragua","NIC",6000000L));
        r.getContinents().add(c);
        regions.add(r);
 
        r = new Region("Latin America","LAT",386000000L);
        c = new Continent("South America", "SA","southAmerica", 386000000L);
        r.getContinents().add(c);
        regions.add(r);
        u = new Country("Brazil","BRA",117000000L);
        u.getRealCities().add(new City("Sao Paulo","Sao Paulo", 20200000L, -23.5489433f , -46.6388182f ));
        u.getRealCities().add(new City("Rio de Janeiro","Rio de Janeiro", 12000000L, -22.9035393f, -43.20958689999998f ));
        u.getRealCities().add(new City("Belo Horizonte","Belo Horizonte", 5500000L,-19.9190677f , -43.93857470000000f));
        c.getRealCountries().add(u);
        
        c.getRealCountries().add(new Country("Argentina","ARG",40500000L));
        
        
        r = new Region("Europe and Africa","EMEA",1732000000L);

        c = new Continent("Europe", "EU", "europe",739000000L);
        r.getContinents().add(c);

        u = new Country("Russia","RUS",    143300000L);
        u.getRealCities().add(new City("Moscow","MOSCOW",        15500000L,55.7512419f , 37.618421f));
        u.getRealCities().add(new City("Saint Petersburg","SAINT_PETERSBURG", 4900000L,59.9395237f , 30.312020599f));
        c.getRealCountries().add(u);
        u = new Country("France","FRA",    63800000L);
        u.getRealCities().add(new City("Paris","PARIS",        10800000L, 48.856614f, 2.35222190000f ));
        c.getRealCountries().add(u);

        u = new Country("UK","GBR",    64200000L);
        u.getRealCities().add(new City("London","LONDON",        8600000L,51.51121389999999f , -0.11982439999997041f ));
        c.getRealCountries().add(u);

        u = new Country("Germany","DEU",    80600000L);
        u.getRealCities().add(new City("Essen","ESSEN",        7300000L,51.4556432f , 7.011555199999975f));
        c.getRealCountries().add(u);

        regions.add(r);

        c = new Continent("Africa", "AF", "africa",995000000L);
        r.getContinents().add(c);

        u = new Country("Nigeria","NGA",  152000000L);
        u.getRealCities().add(new City("Lagos","LAGOS",        11500000L,6.441158f , 3.41797700000f));
        c.getRealCountries().add(u);
        u = new Country("Egypt","EGY",  78800000L);
        u.getRealCities().add(new City("Cairo","CAIRO",        19400000L,30.0444196f , 31.23571160f));
        c.getRealCountries().add(u);
        u = new Country("Ethiopia","ETH",  79200000L);
        c.getRealCountries().add(u);
        u = new Country("South Africa","ZAF",  50000000L);
        u.getRealCities().add(new City("Johannesburg","JOHANNESBURG",        7600000L,-26.2041028f , 28.047305100000f));
        c.getRealCountries().add(u);


        
        r = new Region("Asia and Pacific","APAC",4180000000L);
        c = new Continent("Asia", "AS","asia",4140000000L);
        r.getContinents().add(c);


        
        u = new Country("China","CHN",  1300000000L);
        u.getRealCities().add(new City("Bejing","BEJING",        17300000L, 39.90403f, 116.40752599999996f));
        u.getRealCities().add(new City("Shanghai","SHANGHAI", 21900000L, 31.230393f , 121.47f));
        u.getRealCities().add(new City("Guangzhou","GUANGZHOU", 16800000L, 23.12916f , 113.2644f));
        u.getRealCities().add(new City("Shenzen","SHENZEN", 11900000L,22.543099f , 114.057867f));
        //        u.getRealCities().add(new City("Dallas-Fort Worth","Dallas-Fort Worth", 5800000L));
        c.getRealCountries().add(u);

        u = new Country("Japan","JPN",  127400000L);
        u.getRealCities().add(new City("Tokyo","TOKYO",        37100000L, 35.6894875f , 139.6917063f));
        u.getRealCities().add(new City("Osaka","OSAKA",        17000000L, 34.6937378f , 135.5021650f));
        u.getRealCities().add(new City("Nagoya","NAGOYA", 10000000L, 35.1814464f , 136.90639799f));
        c.getRealCountries().add(u);

        u = new Country("Bangladesh","BGD",  164400000L);
        u.getRealCities().add(new City("Dakha","DAKHA",        14000000L,23.70992f , 90.40714300000f));
        c.getRealCountries().add(u);

        u = new Country("Indonesia","IDN",  234240000L);
        u.getRealCities().add(new City("Jakarta","JAKARTA",        26000000L, -6.211544f , 106.845172000f));
        u.getRealCities().add(new City("Bandung","BANDUNG",        4700000L, -6.9147444f , 107.6098f));
        u.getRealCities().add(new City("Surabaya","SURABAYA", 4600000L, -7.289166000000001f , 112.7343980000f));
        c.getRealCountries().add(u);

        u = new Country("India","IND",  1140000000L);
        u.getRealCities().add(new City("Delhi","DELHI",        22200000L, 28.635308f , 77.224960000f));
        u.getRealCities().add(new City("Mumbai","Mumbai",        16900000L, 19.0759837f , 72.8776559000f));
        u.getRealCities().add(new City("Calcutta","Calcutta", 14400000L, 22.572646f , 88.363894999f));
        u.getRealCities().add(new City("Chennai","Chennai", 8800000L, 13.0524139f , 80.250824599f));
        u.getRealCities().add(new City("Bengaluru","Bengaluru", 8700000L, 12.9715987f , 77.59456269f));
        u.getRealCities().add(new City("Hyderabad","Hyderabad", 7900000L, 17.385044f , 78.48667f));
        c.getRealCountries().add(u);

        u = new Country("Pakistan","PAK",  170000000L);
        u.getRealCities().add(new City("Karachi","Karachi",        20700000L,24.893379f , 67.028060f));
        u.getRealCities().add(new City("Lahore","Lahore", 7700000L, 31.54505f , 74.3406830000f));
        c.getRealCountries().add(u);

        c = new Continent("Oceania", "AU", "australia",47000000L);
        r.getContinents().add(c);
        
        u = new Country("Australia","AUS",  36100000L);
        u.getRealCities().add(new City("Syndey","SYNDEY",   3800000L, -33.8674869f , 151.206990200f));
        u.getRealCities().add(new City("Melbourne","MELBOURNE",   3200000L, -37.81410f , 144.9632799999f));
        c.getRealCountries().add(u);
        u = new Country("New Zealand","NZL",  4500000L);
        u.getRealCities().add(new City("Auckland","AUCKLAND",   1500000L, -36.8484597f , 174.763331500f));
        u.getRealCities().add(new City("Wellington","WELLINGTON",   400000L, -41.2864603f , 174.7762360f));
        u.getRealCities().add(new City("Christchurch","CHRISTCHURCH",   400000L, -43.5320544f , 172.6362254f));
        
        c.getRealCountries().add(u);
        regions.add(r);
    }
    
    

}
